ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.5 by root, Thu Mar 8 15:19:08 2007 UTC vs.
Revision 1.65 by root, Thu Dec 27 15:32:41 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
19use YAML::Syck ();
20use JSON::XS ();
18use IO::AIO (); 21use IO::AIO ();
19use File::Temp; 22use File::Temp;
20use Crossfire; 23use Deliantra;
21use Coro; 24use Coro;
22use Coro::AIO; 25use Coro::AIO;
26use Coro::Util;
23use POSIX (); 27use POSIX ();
28use Carp;
29use Coro::Channel;
30use Coro::Storable; $Storable::canonical = 1;
31
32$SIG{QUIT} = sub { Carp::cluck "QUIT" };
24 33
25sub usage { 34sub usage {
26 warn <<EOF; 35 warn <<EOF;
27Usage: cfutil [-v] [-q] [--force] [--cache] 36Usage: cfutil [-v] [-q] [--force] [--cache]
28 [--install-arch path] 37 [--install-arch path]
40my $CACHE = 0; 49my $CACHE = 0;
41my $FORCE; 50my $FORCE;
42my $TMPDIR = "/tmp/cfutil$$~"; 51my $TMPDIR = "/tmp/cfutil$$~";
43my $TMPFILE = "aaaa0"; 52my $TMPFILE = "aaaa0";
44 53
54our %COLOR = (
55 black => 0,
56 white => 1,
57 navy => 2,
58 red => 3,
59 orange => 4,
60 blue => 5,
61 darkorange => 6,
62 green => 7,
63 lightgreen => 8,
64 grey => 9,
65 brown => 10,
66 gold => 11,
67 tan => 12,
68);
69
45END { system "rm", "-rf", $TMPDIR } 70END { system "rm", "-rf", $TMPDIR }
46 71
47Event->signal (signal => "INT", cb => sub { exit 1 }); 72Event->signal (signal => "INT", cb => sub { exit 1 });
48Event->signal (signal => "TERM", cb => sub { exit 1 }); 73Event->signal (signal => "TERM", cb => sub { exit 1 });
49 74
66} 91}
67 92
68sub inst_maps($) { 93sub inst_maps($) {
69 my (undef, $path) = @_; 94 my (undef, $path) = @_;
70 95
71 print "installing '$path' to '$DATADIR/maps'\n\n"; 96 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
72 97
73 if (!-f "$path/regions") { 98 if (!-f "$path/regions") {
74 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 99 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
75 exit 1 unless $FORCE; 100 exit 1 unless $FORCE;
76 } 101 }
77 102
78 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 103 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
104 "$path/.", "$DATADIR/maps/.",
105 "--exclude", "CVS", "--exclude", "/world-precomposed",
106 "--delete", "--delete-excluded"
107 and die "map installation failed.\n";
108
109 print "maps installed successfully.\n";
79} 110}
80 111
81{ 112{
82 our @PNG; 113 our %ANIMINFO;
114 our %FACEINFO;
115 our %RESOURCE;
83 our @ARC; 116 our @ARC;
117 our %ARC;
118 our $TRS;
84 our $NFILE; 119 our $NFILE;
85 our @FACE;
86 our $ANIM; 120 our $PATH;
87 121
88 our (@png, @trs, @arc); # files we are interested in 122 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
89 123
124 our $c_arc = new Coro::Channel;
125 our $c_trs = new Coro::Channel;
126 our $c_res = new Coro::Channel;
127
128 our @c_png;
129
90 sub commit_png { 130 sub commit_png($$$) {
91 my ($name, $data) = @_; 131 my ($name, $data, $T) = @_;
92 132
93 push @PNG, [$name => $data]; 133 $FACEINFO{$name}{"data$T"} = $data;
94 } 134 }
95 135
96 sub process_png { 136 sub process_png {
97 while (@png) { 137 while (@c_png) {
98 my $path = pop @png; 138 my ($path, $delete) = @{pop @c_png};
99 139
100 my $png; 140 my $png;
101 aio_lstat $path; 141 aio_lstat $path;
102 my ($size, $mtime) = (stat _)[7,9]; 142 my ($size, $mtime) = (stat _)[7,9];
103 143
104 if (0 > aio_load $path, $png) { 144 if (0 > aio_load $path, $png) {
105 warn "$path: $!, skipping.\n"; 145 warn "$path: $!, skipping.\n";
106 next; 146 next;
107 } 147 }
108 148
109 # quickly extratc width and height of the (necessarily PNG) image 149 my $stem = $path;
110 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 150 my $T;
111 warn "$path: not a recongized png file, skipping.\n";
112 next;
113 }
114 151
115 my ($w, $h) = unpack "NN", $1; 152 if ($stem =~ s/\.32x32\.png~?$//) {
116
117 (my $face = $path) =~ s/^.*\///;
118 my $T = 32; 153 $T = 32;
119 154 } elsif ($stem =~ s/\.64x64\.png~?$//) {
120 unless ($face =~ s/\.base\.(...)\.png$/.$1/) { 155 $T = 64;
156 } else {
121 warn "$path: weird filename, skipping.\n"; 157 warn "$path: weird filename, skipping.\n";
122 next; 158 next;
123 } 159 }
160
161 # quickly extract width and height of the (necessarily PNG) image
162 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
163 warn "$path: not a recognized png file, skipping.\n";
164 next;
165 }
166
167 my ($w, $h) = unpack "NN", $1;
124 168
125 if ($w < $T || $h < $T) { 169 if ($w < $T || $h < $T) {
126 warn "$path: too small ($w $h), skipping.\n"; 170 warn "$path: too small ($w $h), skipping.\n";
127 next; 171 next;
128 } 172 }
130 if ($w % $T || $h % $T) { 174 if ($w % $T || $h % $T) {
131 warn "$path: weird png size ($w $h), skipping.\n"; 175 warn "$path: weird png size ($w $h), skipping.\n";
132 next; 176 next;
133 } 177 }
134 178
179 (my $base = $stem) =~ s/^.*\///;
180
181 my $fi = $FACEINFO{$base};
182 unless ($fi) {
183 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
184 #next;
185 }
186
187 my $arc = $fi->{arc} || { };
188
189 unless ($path =~ /~$/) {
190 # possibly enlarge
191 if (0 > aio_stat "$stem.64x64.png") {
192 my $other = "$stem.64x64.png~";
193
194 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
195 fork_sub {
196 my $CROP;
197 my $SRC = "png:\Q$path\E";
198
199 my $is_floor = $arc->{is_floor};
200 my $is_wall = 0;
201
202 my ($wall_pfx, $wall_dir, $wall_sfx);
203
204 if (
205 !$is_floor
206 && !$arc->{alive}
207 && $arc->{move_block} eq "all"
208 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
209 ) {
210 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
211
212 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
213 $is_wall = 1;
214 }
215 }
216
217 if ($is_wall || $is_floor) {
218 # add a 4px border and add other images around it
219 $CROP = "-shave 8x8 +repage";
220
221 $w += 8;
222 $h += 8;
223
224 $SRC = "-size ${w}x${h} xc:transparent";
225 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
226
227 # 8 surrounding images
228 for (
229 # x y b r0 r1
230 [-1, -1, 0, 6],
231 [ 0, -1, 1, 10, 14],
232 [+1, -1, 0, 12],
233
234 [-1, 0, 8, 5, 7],
235 #
236 [+1, 0, 2, 5, 13],
237
238 [-1, +1, 0, 3],
239 [ 0, +1, 4, 10, 11],
240 [+1, +1, 0, 9],
241 ) {
242 my ($x, $y, $d, $r0, $r1) = @$_;
243
244 my $tile = $is_floor ? $path
245 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
246 : die;
247
248 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
249 "\Q$tile",
250 $x * ($w - 8) + 4,
251 $y * ($h - 8) + 4;
252 }
253 }
254
255 system "convert -depth 8 $SRC rgba:-"
256 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
257 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
258 and die "convert/cfhq2xa pipeline error: status $? ($!)";
259 system $OPTIPNG, "-i0", "-q", "$other~";
260 die "$other~ has zero size, aborting." unless -s "$other~";
261 rename "$other~", $other;
262 };
263 }
264
265 push @c_png, [$other, !$CACHE];
266 }
267
268 # possibly scale down
269 if (0 > aio_stat "$stem.32x32.png") {
270 my $other = "$stem.32x32.png~";
271
272 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
273 fork_sub {
274 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
275 system $OPTIPNG, "-i0", "-q", "$other~";
276
277 # reduce smoothfaces >10000 bytes
278 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
279 my $ncolor = 256;
280 while () {
281 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
282 system $OPTIPNG, "-i0", "-q", "$other~~";
283 last if 10000 > -s "$other~~";
284 $ncolor = int $ncolor * 0.9;
285 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
286 }
287
288 printf "reduced %s from %d to %d bytes using %d colours.\n",
289 $other, -s "$other~", -s "$other~~", $ncolor
290 if $VERBOSE >= 2;
291 rename "$other~~", "$other~";
292 }
293
294 die "$other~ has zero size, aborting." unless -s "$other~";
295 rename "$other~", $other;
296 };
297 }
298
299 #warn "scaled down $path to $other\n";#d#
300 push @c_png, [$other, !$CACHE];
301 }
302 }
303
304 (my $face = $stem) =~ s/^.*\///;
305
306 # split all bigfaces, but avoid smoothfaces (*_S)
135 if (($w > $T || $h > $T) && $face !~ /_S\./) { 307 if (($w > $T || $h > $T) && $face !~ /_S\./) {
136 # split 308 # split
137 my @tile; 309 my @tile;
138 for my $x (0 .. (int $w / $T) - 1) { 310 for my $x (0 .. (int $w / $T) - 1) {
139 for my $y (0 .. (int $h / $T) - 1) { 311 for my $y (0 .. (int $h / $T) - 1) {
147 my @todo = grep { $_->[3] <= $mtime } @tile; 319 my @todo = grep { $_->[3] <= $mtime } @tile;
148 if (@todo) { 320 if (@todo) {
149 fork_sub { 321 fork_sub {
150 open my $convert, "|-", $CONVERT, 322 open my $convert, "|-", $CONVERT,
151 "png:-", 323 "png:-",
152 -negate,#d#
153 (map { 324 (map {
154 ( 325 (
155 "(", 326 "(",
156 "+clone", 327 "+clone",
157 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 328 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
329 "+repage",
330 -quality => "00",
158 -write => "png:$_->[2]~", 331 -write => "png32:$_->[2]~",
159 "+delete", 332 "+delete",
160 ")", 333 ")",
161 ) 334 )
162 } @todo), 335 } @todo),
163 "null:"; 336 "null:";
167 close $convert; 340 close $convert;
168 341
169 # pass 2, optimise, and rename 342 # pass 2, optimise, and rename
170 for (@todo) { 343 for (@todo) {
171 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 344 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
345 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
172 rename "$_->[2]~", $_->[2]; 346 rename "$_->[2]~", $_->[2];
173 } 347 }
174 }; 348 };
175 } 349 }
176 350
180 354
181 if (0 > aio_load $file, $tile) { 355 if (0 > aio_load $file, $tile) {
182 die "$path: unable to read tile +$x+$y, aborting.\n"; 356 die "$path: unable to read tile +$x+$y, aborting.\n";
183 } 357 }
184 IO::AIO::aio_unlink $file unless $CACHE; 358 IO::AIO::aio_unlink $file unless $CACHE;
185 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 359 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
186 } 360 }
187 } else { 361 } else {
188 # use as-is (either small, use smooth) 362 # use as-is (either small, use smooth)
189 commit_png $face, $png; 363 commit_png $face, $png, $T;
190 } 364 }
365
366 aio_unlink $path if $delete;
191 } 367 }
192 } 368 }
193 369
194 sub process_arc { 370 sub process_arc {
195 while (@arc) { 371 while (my $job = $c_arc->get) {
196 my ($dir, $file) = @{pop @arc}; 372 my ($dir, $file) = @$job;
197 373
198 my $arc; 374 my $arc;
199 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 375 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
200 376
201 my $arc = read_arch "$dir/$file"; 377 my $arc = read_arch "$dir/$file";
202 for my $o (values %$arc) { 378 for my $o (values %$arc) {
203 push @ARC, $o; 379 push @ARC, $o;
380 for (my $m = $o; $m; $m = $m->{more}) {
381 $ARC{$m->{_name}} = $m;
382 }
383
384 $o->{editor_folder} = $dir;
385
386 my $visibility = delete $o->{visibility};
387 my $magicmap = delete $o->{magicmap};
388
389 # find upper left corner :/
390 # omg, this is sooo broken
204 my ($dx, $dy); 391 my ($dx, $dy);
205 # omg, this is sooo broken
206 for (my $o = $o; $o; $o = $o->{more}) { 392 for (my $o = $o; $o; $o = $o->{more}) {
207 $dx = $o->{x} if $o->{x} < $dx; 393 $dx = $o->{x} if $o->{x} < $dx;
208 $dy = $o->{y} if $o->{y} < $dy; 394 $dy = $o->{y} if $o->{y} < $dy;
209 } 395 }
396
210 for (my $o = $o; $o; $o = $o->{more}) { 397 for (my $o = $o; $o; $o = $o->{more}) {
211 my $x = $o->{x} - $dx; 398 my $x = $o->{x} - $dx;
212 my $y = $o->{y} - $dy; 399 my $y = $o->{y} - $dy;
213 if ($x|$y) { 400
214 $_ .= "+$x+$y" for $o->{face}, @{$o->{anim} || []}; 401 my $ext = $x|$y ? "+$x+$y" : "";
215 } 402
216 } 403 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
404
405 $visibility = delete $o->{visibility} if exists $o->{visibility};
406 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
407
217 if (my $anim = delete $o->{anim}) { 408 my $anim = delete $o->{anim};
409
410 if ($anim) {
411 # possibly add $ext to the animation name to avoid
412 # the need to specify archnames for all parts
413 # of a multipart archetype.
218 $o->{animation} = $o->{_name}; 414 $o->{animation} = "$o->{_name}";
219 $ANIM .= join "", map "$_\n", 415 my $facings = 1;
220 "anim $o->{_name}", 416 my @frames;
417
418 for (@$anim) {
419 if (/^facings\s+(\d+)/) {
420 $facings = $1*1;
421 } elsif (/^blank.x11$|^empty.x11$/) {
422 push @frames, $_;
423 } else {
424 push @frames, "$_$ext";
221 @$anim, 425 }
222 "mina"; 426 }
427
428 $ANIMINFO{$o->{animation}} = {
429 facings => $facings,
430 frames => \@frames,
431 };
432 }
433
434 for ($o->{face} || (), @{$anim || []}) {
435 next if /^facings\s/;
436
437 my $face = $_;
438 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
439
440 my $info = $FACEINFO{$face} ||= { };
441 $info->{arc} = $o;
442
443 next if $face =~ /^blank.x11$|^empty.x11$/;
444
445 $info->{visibility} = $visibility if defined $visibility;
446 $info->{magicmap} = $magicmap if defined $magicmap;
447 }
448
449 if (my $smooth = delete $o->{smoothface}) {
450 my %kv = split /\s+/, $smooth;
451 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
452 while (my ($face, $smooth) = each %kv) {
453 $FACEINFO{$smooth}{arc} = $o;
454
455 $FACEINFO{$face}{smooth} = $smooth;
456 $FACEINFO{$face}{smoothlevel} = $level;
457 }
458 }
223 } 459 }
224 } 460 }
225 } 461 }
226 } 462 }
227 463
228 sub process_trs { 464 sub process_trs {
229 while (@trs) { 465 while (my $job = $c_trs->get) {
230 my ($dir, $file) = @{pop @trs}; 466 my ($dir, $file) = @$job;
467 my $path = "$dir/$file";
468
469 my $trs;
470 if (0 > aio_load $path, $trs) {
471 warn "$path: $!, skipping.\n";
472 next;
473 }
474
475 $TRS .= $trs;
476 }
477 }
478
479 my %FILECACHE;
480
481 sub load_cached($;$) {
482 unless (exists $FILECACHE{$_[0]}) {
483 my $data;
484 if (0 < aio_load $_[0], $data) {
485 if ($_[1]) {
486 $data = eval { $_[1]->($data) };
487 warn "$_[0]: $@" if $@;
488 }
489 }
490
491 $FILECACHE{$_[0]} = $data;
492 }
493
494 $FILECACHE{$_[0]}
495 }
496
497 sub process_res {
498 while (my $job = $c_res->get) {
499 my ($dir, $file, $type) = @$job;
500
501 my $data;
502 aio_load "$dir/$file", $data;
503
504 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
505
506 utf8::decode $dir;
507 utf8::decode $file;
508
509 # a meta file for resources is now mandatory
510 unless (exists $meta->{$file}) {
511 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
512 next;
513 }
514
515 $meta = {
516 %{ $meta->{"" } || {} },
517 %{ $meta->{$file} || {} },
518 };
519
520 if ($meta->{license} =~ s/^#//) {
521 $meta->{license} = ({
522 "pd" => "Public Domain",
523 "gpl" => "GNU General Public License, version 3.0 or any later",
524 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
525 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
526 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
527 })->{$meta->{license}}
528 || warn "$dir/$file: license tag '$meta->{license}' not found.";
529 }
530
531 $file =~ s/\.res$//;
532 $file =~ s/\.(ogg|wav|jpg|png)$//;
533
534 substr $dir, 0, 1 + length $PATH, "";
535
536 if (my $filter = $meta->{cfutil_filter}) {
537 if ($filter eq "yaml2json") {
538 $data = JSON::XS::encode_json YAML::Syck::Load $data;
539 } elsif ($filter eq "json2json") {
540 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
541 } else {
542 warn "$dir/$file: unknown filter $filter, skipping\n";
543 }
544 }
545
546 $RESOURCE{"$dir/$file"} = {
547 type => (exists $meta->{type} ? delete $meta->{type} : $type),
548 data => $data,
549 %$meta ? (meta => $meta) : (),
550 };
231 } 551 }
232 } 552 }
233 553
234 sub find_files; 554 sub find_files;
235 sub find_files { 555 sub find_files {
240 my ($dirs, $nondirs) = @_; 560 my ($dirs, $nondirs) = @_;
241 561
242 find_files "$path/$_" 562 find_files "$path/$_"
243 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 563 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
244 564
565 my $dir = $path;
566 substr $dir, 0, 1 + length $PATH, "";
567
245 for my $file (@$nondirs) { 568 for my $file (@$nondirs) {
569 if ($dir =~ /^music(?:\/|$)/) {
570 $c_res->put ([$path, $file, 3]) # FT_MUSIC
571 if $file =~ /\.(ogg)$/;
572
573 } elsif ($dir =~ /^sound(?:\/|$)/) {
574 $c_res->put ([$path, $file, 5]) # FT_SOUND
575 if $file =~ /\.(wav|ogg)$/;
576
577 } elsif ($dir =~ /^res(?:\/|$)/) {
578 if ($file =~ /\.(jpg|png)$/) {
579 $c_res->put ([$path, $file, 0]) # FT_FACE
580 } elsif ($file =~ /\.(res)$/) {
581 $c_res->put ([$path, $file, 7]) # FT_RSRC
582 } else {
583 $c_res->put ([$path, $file, undef]);
584 }
585
246 if ($file =~ /\.png$/) { 586 } elsif ($file =~ /\.png$/) {
247 push @png, "$path/$file"; 587 push @c_png, ["$path/$file", 0];
588
248 } elsif ($file =~ /\.trs$/) { 589 } elsif ($file =~ /\.trs$/) {
249 push @trs, [$path, $file]; 590 $c_trs->put ([$path, $file]);
591
250 } elsif ($file =~ /\.arc$/) { 592 } elsif ($file =~ /\.arc$/) {
251 push @arc, [$path, $file]; 593 $c_arc->put ([$path, $file]);
594
252 } else { 595 } else {
253 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 596 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
254 } 597 }
255 } 598 }
256 }; 599 };
257 } 600 }
258 601
259 sub inst_arch($) { 602 sub inst_arch($) {
260 my (undef, $path) = @_; 603 my (undef, $path) = @_;
261 604
605 $PATH = $path;
606
607 print "\n",
262 print "installing '$path' to '$DATADIR'\n\n"; 608 "Installing '$path' to '$DATADIR'\n",
609 "\n",
610 "This can take a long time if you run this\n",
611 "for the first time or do not use --cache.\n",
612 "\n",
613 "Unless you run verbosely, all following warning\n",
614 "or error messages indicate serious problems.\n",
615 "\n";
263 616
264 if (!-d "$path/treasures") { 617 if (!-d "$path/treasures") {
265 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 618 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
266 exit 1 unless $FORCE; 619 exit 1 unless $FORCE;
267 } 620 }
268 621
622 print "scanning files...\n" if $VERBOSE;
623
269 find_files $path; 624 find_files $path;
625
626 my @a_arc = map +(async \&process_arc), 1..2;
627 my @a_res = map +(async \&process_res), 1..2;
628 my @a_trs = map +(async \&process_trs), 1..2;
629
270 IO::AIO::flush; 630 IO::AIO::flush;
271 631
272 $_->join for ( 632 $c_res->put (undef) for @a_res;
273 (async \&process_png), (async \&process_png), 633 $c_arc->put (undef) for @a_arc;
274 (async \&process_trs), (async \&process_trs), 634 $c_trs->put (undef) for @a_trs;
275 (async \&process_arc), (async \&process_arc),
276 );
277 635
636 print "start file scan, arc, res processing...\n" if $VERBOSE;
637
638 $_->join for @a_arc; # need to parse all archetypes before png processing
639
640 print "end arc, start png processing...\n" if $VERBOSE;
641
642 # four png crunchers work fine for my 2x smp machine
643 my @a_png = map +(async \&process_png), 1..4;
644
645 $_->join for (@a_trs, @a_res, @a_png);
646
647 print "scanning done, processing results...\n" if $VERBOSE;
278 { 648 {
279 open my $fh, ">:utf8", "$DATADIR/animations~" 649 # remove path prefix from editor_folder
280 or die "$DATADIR/animations~: $!"; 650 substr $_->{editor_folder}, 0, 1 + length $path, ""
281 print $fh $ANIM; 651 for values %ARC;
652
653 print "resolving inheritance tree...\n" if $VERBOSE;
654 # resolve inherit
655 while () {
656 my $progress;
657 my $loop;
658
659 for my $o (values %ARC) {
660 if (my $other = $o->{inherit}) {
661 if (my $s = $ARC{$other}) {
662 if ($s->{inherit}) {
663 $loop = $s;
664 } else {
665 delete $o->{inherit};
666 my %s = %$s;
667 delete @s{qw(_name more name name_pl)};
668 %$o = ( %s, %$o );
669 ++$progress;
670 }
671 } else {
672 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
673 delete $ARC{$o->{_name}};
674 }
675 }
676 }
677
678 unless ($progress) {
679 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
680 if $loop;
681
682 last;
683 }
282 } 684 }
283 685
284 { 686 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
687 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
688
689 print "writing archetypes...\n" if $VERBOSE;
285 open my $fh, ">:utf8", "$DATADIR/archetypes~" 690 open my $fh, ">:utf8", "$DATADIR/archetypes~"
286 or die "$DATADIR/archetypes~: $!"; 691 or die "$DATADIR/archetypes~: $!";
287 print $fh Crossfire::archlist_to_string \@ARC; 692 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
288 } 693 }
289
290 @PNG = sort { $a->[0] cmp $b->[0] } @PNG;
291 694
292 { 695 {
696 print "writing treasures...\n" if $VERBOSE;
697 open my $fh, ">:utf8", "$DATADIR/treasures~"
698 or die "$DATADIR/treasures~: $!";
699 print $fh $TRS;
700 }
701
702 {
703 print "processing facedata...\n" if $VERBOSE;
704 while (my ($k, $v) = each %FACEINFO) {
705 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
706 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
707
708 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
709 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
710
711 if (my $magicmap = $v->{magicmap}) {
712 $magicmap =~ y/A-Z_\-/a-z/d;
713 $v->{magicmap} = $COLOR{$magicmap};
714 }
715
716 delete $v->{arc};
717 }
718
719 print "writing facedata...\n" if $VERBOSE;
293 open my $fh, ">:perlio", "$DATADIR/crossfire.0~" 720 open my $fh, ">:perlio", "$DATADIR/facedata~"
294 or die "$DATADIR/crossfire.0~: $!"; 721 or die "$DATADIR/facedata~: $!";
295 printf $fh "IMAGE %d %d %s\x0a%s", $_, (length $PNG[$_][1]), $PNG[$_][0], $PNG[$_][1] 722
296 for 0.. $#PNG; 723 print $fh freeze {
724 version => 2,
725 faceinfo => \%FACEINFO,
726 animinfo => \%ANIMINFO,
727 resource => \%RESOURCE,
297 } 728 };
729 }
298 730
299 rename "$DATADIR/archetypes~" , "$DATADIR/archetypes"; 731 print "committing files...\n" if $VERBOSE;
300 rename "$DATADIR/crossfire.0~", "$DATADIR/crossfire.0";
301 rename "$DATADIR/animations~" , "$DATADIR/animations";
302 732
303 die "--install-arch not fully implemented\n"; 733 for (qw(archetypes facedata treasures)) {
734 chmod 0644, "$DATADIR/$_~";
735 rename "$DATADIR/$_~", "$DATADIR/$_"
736 or die "$DATADIR/$_: $!";
737 }
738
739 print "archetype data installed successfully.\n";
304 } 740 }
305} 741}
306 742
307Getopt::Long::Configure ("bundling", "no_ignore_case"); 743Getopt::Long::Configure ("bundling", "no_ignore_case");
308GetOptions ( 744GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines